//
//  $Id: PrintCardTest.cc,v 1.3 2000/06/07 06:53:12 sergey Exp $
//

#include <Pilot.h>
#include <stdio.h>
#include "Test.h"


//==============================================================================
// All test cases executed here
//==============================================================================

class AllTests: public Test
{
public:
    virtual const char* name() const { return "AllTests"; }

    virtual void runTest()
    {
        // DB

        extern Test& GetDatabaseTest();
        GetDatabaseTest().run(testResult());

        extern Test& GetResourceDatabaseTest();
        GetResourceDatabaseTest().run(testResult());

        extern Test& GetAddressDatabaseTest();
        GetAddressDatabaseTest().run(testResult());

        // Util

        extern Test& GetMemBufferTest();
        GetMemBufferTest().run(testResult());

        extern Test& GetTemplateTranslatorTest();
        GetTemplateTranslatorTest().run(testResult());

        extern Test& GetAppPreferencesStreamTest();
        GetAppPreferencesStreamTest().run(testResult());
    }
};


//==============================================================================
// Test result logger class
//==============================================================================

class TestResultLogger: public TestResult
{
public:
    TestResultLogger(): errors(0) {}

    virtual void logMessage(const char* testName, const char* message)
    {
        printf("%s: %s\n", testName, message);
    }

    virtual void logError(const char* testName, const TestError& e)
    {
        ++errors;
        printf("%s: %s in file '%s' line %d\n", testName, e.message(), e.file(), e.line());
    }

    int errors;
};

//==============================================================================

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
    if (cmd == sysAppLaunchCmdNormalLaunch)
    {
        TestResultLogger result;

        AllTests test;
        test.run(result);

        if (result.errors == 0)
            printf("SUCCESS\n");
        else
            printf("FAILED\n");

        EventType e;
        do
        {
            EvtGetEvent(&e, evtWaitForever);
            SysHandleEvent(&e);
        }
        while (e.eType != appStopEvent);
    }

    return 0;
}
